

#include "vtkapp.h"
#include "gui.h"

#include <iostream>
#include <string>
using namespace std;

typedef struct WinAPIParam_s
{
	HINSTANCE* hInst;
	HINSTANCE* hPrevInst;
	HWND*	hParent;
	LPSTR lpstr;
	INT	nCmdShow;
	int x;
	int y;
	int width;
	int height;

} WinApiParam;

//		GLOBAL VARIABLE
//-----------------------------
MyVTKApp *g_pVTKApp = NULL;

//		FUNCTION PROTOTYPES
//-----------------------------

void* SetupRenderApp(void*);
void PreRenderSetup(void);		//Setup whatever you want before the rendering actually takes place...good way to test using CgFX files?
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );	//Main Message Processor for the main window
INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE hInst2, LPSTR str, INT  nCmdShow );	//Entry function into program


//		FUNCTION IMPLEMENTATION
//-----------------------------

//-----------------------------

void* SetupRenderApp(void* pParameter)
{


	WinApiParam* pData = (WinApiParam*) pParameter;

    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "VTK for Windows", NULL };

    RegisterClassEx( &wc );
	printf("registered window class\n");

    // Create the application's window.
	HWND hWnd = CreateWindow( "VTK for Windows", "VTK : VTK_1", //The first string is the window class name of the window class we want
																//to instantiate, the next part is what actually goes up on the title bar
                              0 , pData->x, pData->y, pData->width, pData->height,
                               *(pData->hParent), NULL, wc.hInstance, NULL );

	printf("looping\n");

	//make the instance of the application
	g_pVTKApp = new MyVTKApp(hWnd , 800, 600);

	ShowWindow( hWnd, pData->nCmdShow);	
	UpdateWindow( hWnd );


	// The message loop.
	MSG msg; 
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );

		//process vtk app messages
		g_pVTKApp->ProcessMessages();
	}

	

	MessageBox( NULL, "Wait", "Wait", MB_OK);
	return NULL;
			
}
void PreRenderSetup(void)
{

}



//-----------------------------
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	

	switch( msg )
    {
	case WM_CREATE:
			//Initialize QUANTA...allocate memory for the global thread for the GUI, 
			//assign proper initial values to the object used as the thread parameter
			//Then start the thread



			
			break;

    case WM_DESTROY:
			//Clean up and exit

            PostQuitMessage( 0 );
            delete g_pVTKApp;
			DestroyWindow( hWnd );
			exit(0);
		/*	if( !g_pGUIThread->isRunning() )
			{	
				g_pGUIThread->stop();
			}
*/
			
			return 0;

			break;
	case WM_PAINT:

		//Do any pre rendering setup
		//then render.
		PreRenderSetup();
		if( g_pVTKApp )
			g_pVTKApp->Render();

		break;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}




//-----------------------------
INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpstr, INT  nCmdShow )
{


	// init quanta.
	
	QUANTAinit();
	
	//create object to pass windows parameters
	WinApiParam winParam;
	winParam.hInst = &hInst;
	winParam.hPrevInst = &hPrevInst;
	winParam.lpstr = lpstr;
	winParam.nCmdShow = nCmdShow;
	winParam.x = 0;
	winParam.y = 0;
	winParam.width = 800;
	winParam.height = 600;
	HWND hwnd = GetDesktopWindow();

	winParam.hParent = &hwnd;
	//setup the render thread
	QUANTAts_thread_c *pRenderThread = new QUANTAts_thread_c();
	pRenderThread->create(SetupRenderApp,(void*)&winParam);
	pRenderThread->run();

	//create parameters necessary for GUIMain
	GUIThreadData tData;
	tData.argc = 0;
	tData.argv = NULL;
	tData.returnVal = 0;
	tData.ppVTKApp = &g_pVTKApp;
	tData.x = 810;
	tData.y = 0;
	tData.width = 450;
	tData.height = 600;

	//Run the GUI
	GUIMain( (void*) &tData);
	
	QUANTAexit();
	pRenderThread->stop();


}	// end WinMain